import React, { ComponentType, ReactNode, Dispatch, SetStateAction } from 'react';
import { ComponentModel } from '@teambit/component';
import { LanesModel } from '@teambit/lanes.ui.models.lanes-model';
export declare type ComponentFilters = Array<ComponentFilterCriteria<any>>;
export declare type ComponentFilterRenderProps = {
    components: ComponentModel[];
    lanes?: LanesModel;
} & React.HTMLAttributes<HTMLDivElement>;
export declare type ComponentFilterCriteria<State> = {
    id: string;
    render: ComponentType<ComponentFilterRenderProps>;
    match: (data: {
        component: ComponentModel;
        lanes?: LanesModel;
    }, state: State) => boolean;
    state: State;
    order?: number;
};
export declare type ComponentFilterContextType = {
    filters: ComponentFilters;
    setFilters: React.Dispatch<React.SetStateAction<ComponentFilters>>;
};
export declare const ComponentFilterContext: React.Context<ComponentFilterContextType>;
export declare function useComponentFilter<T>(filterId: string, defaultState?: T): [ComponentFilterCriteria<T>, Dispatch<SetStateAction<ComponentFilterCriteria<T>>>] | undefined;
export declare function useComponentFilters(): [ComponentFilters, React.Dispatch<React.SetStateAction<ComponentFilters>>] | undefined;
export declare const ComponentFiltersProvider: ({ children, filters, }: {
    children: ReactNode;
    filters?: ComponentFilters;
}) => JSX.Element;
export declare const runAllFilters: (filters: ComponentFilters, data: {
    components: ComponentModel[];
    lanes?: LanesModel;
}) => ComponentModel[];
