"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runAllFilters = exports.ComponentFiltersProvider = exports.useComponentFilters = exports.useComponentFilter = exports.ComponentFilterContext = void 0;
const react_1 = __importStar(require("react"));
const lodash_1 = require("lodash");
exports.ComponentFilterContext = (0, react_1.createContext)(undefined);
const updateFilter = (filterContext, updatedFilter) => {
    filterContext.setFilters((currentFilters) => {
        return currentFilters.map((currentFilter) => {
            if (currentFilter.id === (updatedFilter === null || updatedFilter === void 0 ? void 0 : updatedFilter.id))
                return updatedFilter;
            return currentFilter;
        });
    });
};
function useComponentFilter(filterId, defaultState) {
    const filterContext = (0, react_1.useContext)(exports.ComponentFilterContext);
    const filterFromContext = filterContext === null || filterContext === void 0 ? void 0 : filterContext.filters.find((existingFilter) => existingFilter.id === filterId);
    (0, react_1.useEffect)(() => {
        if (filterFromContext && defaultState) {
            const initialFilterState = Object.assign(Object.assign({}, filterFromContext), { state: defaultState });
            updateFilter(filterContext, initialFilterState);
        }
    }, [filterId]);
    if (!filterContext || !filterFromContext)
        return undefined;
    const setState = (updatedState) => {
        const nextState = (0, lodash_1.isFunction)(updatedState) ? updatedState(filterFromContext) : updatedState;
        updateFilter(filterContext, nextState);
    };
    return [filterFromContext, setState];
}
exports.useComponentFilter = useComponentFilter;
function useComponentFilters() {
    const filterContext = (0, react_1.useContext)(exports.ComponentFilterContext);
    return filterContext ? [filterContext.filters, filterContext.setFilters] : undefined;
}
exports.useComponentFilters = useComponentFilters;
const ComponentFiltersProvider = ({ children, filters, }) => {
    const [filtersState, setFilters] = (0, react_1.useState)(filters || []);
    return (react_1.default.createElement(exports.ComponentFilterContext.Provider, { value: {
            filters: filtersState,
            setFilters,
        } }, children));
};
exports.ComponentFiltersProvider = ComponentFiltersProvider;
const runAllFilters = (filters, { components, lanes }) => {
    return components.filter((component) => filters.every((filter) => filter.match({ component, lanes }, filter.state)));
};
exports.runAllFilters = runAllFilters;
//# sourceMappingURL=component-filter-context.js.map